--- old/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
+++ new/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
@@ -3115,15 +2903,106 @@
 		spa->spa_l2cache.sav_sync = B_TRUE;
 	}
 
-	return (0);
-}
+	mp = &spa->spa_meta_policy;
 
-static int
-spa_ld_load_vdev_metadata(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
+	spa->spa_delegation = zpool_prop_default_numeric(ZPOOL_PROP_DELEGATION);
+	spa->spa_hiwat = zpool_prop_default_numeric(ZPOOL_PROP_HIWATERMARK);
+	spa->spa_lowat = zpool_prop_default_numeric(ZPOOL_PROP_LOWATERMARK);
+	spa->spa_minwat = zpool_prop_default_numeric(ZPOOL_PROP_MINWATERMARK);
+	spa->spa_dedup_lo_best_effort =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUP_LO_BEST_EFFORT);
+	spa->spa_dedup_hi_best_effort =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUP_HI_BEST_EFFORT);
 
+	mp->spa_enable_meta_placement_selection =
+	    zpool_prop_default_numeric(ZPOOL_PROP_META_PLACEMENT);
+	mp->spa_sync_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_SYNC_TO_SPECIAL);
+	mp->spa_ddt_meta_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DDT_META_TO_METADEV);
+	mp->spa_zfs_meta_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_ZFS_META_TO_METADEV);
+	mp->spa_small_data_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_SMALL_DATA_TO_METADEV);
+	spa_set_ddt_classes(spa,
+	    zpool_prop_default_numeric(ZPOOL_PROP_DDT_DESEGREGATION));
+
+	spa->spa_resilver_prio =
+	    zpool_prop_default_numeric(ZPOOL_PROP_RESILVER_PRIO);
+	spa->spa_scrub_prio = zpool_prop_default_numeric(ZPOOL_PROP_SCRUB_PRIO);
+
+	error = spa_dir_prop(spa, DMU_POOL_PROPS, &spa->spa_pool_props_object);
+	if (error && error != ENOENT)
+		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
+
+	if (error == 0) {
+		uint64_t autoreplace;
+		uint64_t val = 0;
+
+		spa_prop_find(spa, ZPOOL_PROP_BOOTFS, &spa->spa_bootfs);
+		spa_prop_find(spa, ZPOOL_PROP_AUTOREPLACE, &autoreplace);
+		spa_prop_find(spa, ZPOOL_PROP_DELEGATION, &spa->spa_delegation);
+		spa_prop_find(spa, ZPOOL_PROP_FAILUREMODE, &spa->spa_failmode);
+		spa_prop_find(spa, ZPOOL_PROP_AUTOEXPAND, &spa->spa_autoexpand);
+		spa_prop_find(spa, ZPOOL_PROP_BOOTSIZE, &spa->spa_bootsize);
+		spa_prop_find(spa, ZPOOL_PROP_DEDUPDITTO,
+		    &spa->spa_dedup_ditto);
+		spa_prop_find(spa, ZPOOL_PROP_FORCETRIM, &spa->spa_force_trim);
+
+		mutex_enter(&spa->spa_auto_trim_lock);
+		spa_prop_find(spa, ZPOOL_PROP_AUTOTRIM, &spa->spa_auto_trim);
+		if (spa->spa_auto_trim == SPA_AUTO_TRIM_ON)
+			spa_auto_trim_taskq_create(spa);
+		mutex_exit(&spa->spa_auto_trim_lock);
+
+		spa_prop_find(spa, ZPOOL_PROP_HIWATERMARK, &spa->spa_hiwat);
+		spa_prop_find(spa, ZPOOL_PROP_LOWATERMARK, &spa->spa_lowat);
+		spa_prop_find(spa, ZPOOL_PROP_MINWATERMARK, &spa->spa_minwat);
+		spa_prop_find(spa, ZPOOL_PROP_DEDUPMETA_DITTO,
+		    &spa->spa_ddt_meta_copies);
+		spa_prop_find(spa, ZPOOL_PROP_DDT_DESEGREGATION, &val);
+		spa_set_ddt_classes(spa, val);
+
+		spa_prop_find(spa, ZPOOL_PROP_RESILVER_PRIO,
+		    &spa->spa_resilver_prio);
+		spa_prop_find(spa, ZPOOL_PROP_SCRUB_PRIO,
+		    &spa->spa_scrub_prio);
+
+		spa_prop_find(spa, ZPOOL_PROP_DEDUP_BEST_EFFORT,
+		    &spa->spa_dedup_best_effort);
+		spa_prop_find(spa, ZPOOL_PROP_DEDUP_LO_BEST_EFFORT,
+		    &spa->spa_dedup_lo_best_effort);
+		spa_prop_find(spa, ZPOOL_PROP_DEDUP_HI_BEST_EFFORT,
+		    &spa->spa_dedup_hi_best_effort);
+
+		spa_prop_find(spa, ZPOOL_PROP_META_PLACEMENT,
+		    &mp->spa_enable_meta_placement_selection);
+		spa_prop_find(spa, ZPOOL_PROP_SYNC_TO_SPECIAL,
+		    &mp->spa_sync_to_special);
+		spa_prop_find(spa, ZPOOL_PROP_DDT_META_TO_METADEV,
+		    &mp->spa_ddt_meta_to_special);
+		spa_prop_find(spa, ZPOOL_PROP_ZFS_META_TO_METADEV,
+		    &mp->spa_zfs_meta_to_special);
+		spa_prop_find(spa, ZPOOL_PROP_SMALL_DATA_TO_METADEV,
+		    &mp->spa_small_data_to_special);
+
+		spa->spa_autoreplace = (autoreplace != 0);
+	}
+
+	error = spa_dir_prop(spa, DMU_POOL_COS_PROPS,
+	    &spa->spa_cos_props_object);
+	if (error == 0)
+		(void) spa_load_cos_props(spa);
+	error = spa_dir_prop(spa, DMU_POOL_VDEV_PROPS,
+	    &spa->spa_vdev_props_object);
+	if (error == 0)
+		(void) spa_load_vdev_props(spa);
+
+	(void) spa_dir_prop(spa, DMU_POOL_TRIM_START_TIME,
+	    &spa->spa_man_trim_start_time);
+	(void) spa_dir_prop(spa, DMU_POOL_TRIM_STOP_TIME,
+	    &spa->spa_man_trim_stop_time);
+
 	/*
 	 * If the 'autoreplace' property is set, then post a resource notifying
 	 * the ZFS DE that it should not issue any faults for unopenable
@@ -3131,7 +3010,7 @@
 	 * unopenable vdevs so that the normal autoreplace handler can take
 	 * over.
 	 */
-	if (spa->spa_autoreplace && spa->spa_load_state != SPA_LOAD_TRYIMPORT) {
+	if (spa->spa_autoreplace && state != SPA_LOAD_TRYIMPORT) {
 		spa_check_removed(spa->spa_root_vdev);
 		/*
 		 * For the import case, this is done in spa_import(), because
@@ -3138,7 +3017,7 @@
 		 * at this point we're using the spare definitions from
 		 * the MOS config, not necessarily from the userland config.
 		 */
-		if (spa->spa_load_state != SPA_LOAD_IMPORT) {
+		if (state != SPA_LOAD_IMPORT) {
 			spa_aux_check_removed(&spa->spa_spares);
 			spa_aux_check_removed(&spa->spa_l2cache);
 		}
@@ -3145,325 +3024,62 @@
 	}
 
 	/*
-	 * Load the vdev metadata such as metaslabs, DTLs, spacemap object, etc.
+	 * Load the vdev state for all toplevel vdevs.
 	 */
-	error = vdev_load(rvd);
-	if (error != 0) {
-		spa_load_failed(spa, "vdev_load failed [error=%d]", error);
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, error));
-	}
+	vdev_load(rvd);
 
 	/*
-	 * Propagate the leaf DTLs we just loaded all the way up the vdev tree.
+	 * Propagate the leaf DTLs we just loaded all the way up the tree.
 	 */
 	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
 	vdev_dtl_reassess(rvd, 0, 0, B_FALSE);
 	spa_config_exit(spa, SCL_ALL, FTAG);
 
-	return (0);
-}
-
-static int
-spa_ld_load_dedup_tables(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
-	error = ddt_load(spa);
-	if (error != 0) {
-		spa_load_failed(spa, "ddt_load failed [error=%d]", error);
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_verify_logs(spa_t *spa, spa_import_type_t type, char **ereport)
-{
-	vdev_t *rvd = spa->spa_root_vdev;
-
-	if (type != SPA_IMPORT_ASSEMBLE && spa_writeable(spa)) {
-		boolean_t missing = spa_check_logs(spa);
-		if (missing) {
-			if (spa->spa_missing_tvds != 0) {
-				spa_load_note(spa, "spa_check_logs failed "
-				    "so dropping the logs");
-			} else {
-				*ereport = FM_EREPORT_ZFS_LOG_REPLAY;
-				spa_load_failed(spa, "spa_check_logs failed");
-				return (spa_vdev_err(rvd, VDEV_AUX_BAD_LOG,
-				    ENXIO));
-			}
-		}
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_verify_pool_data(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
 	/*
-	 * We've successfully opened the pool, verify that we're ready
-	 * to start pushing transactions.
+	 * Load the DDTs (dedup tables).
 	 */
-	if (spa->spa_load_state != SPA_LOAD_TRYIMPORT) {
-		error = spa_load_verify(spa);
-		if (error != 0) {
-			spa_load_failed(spa, "spa_load_verify failed "
-			    "[error=%d]", error);
-			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA,
-			    error));
-		}
-	}
-
-	return (0);
-}
-
-static void
-spa_ld_claim_log_blocks(spa_t *spa)
-{
-	dmu_tx_t *tx;
-	dsl_pool_t *dp = spa_get_dsl(spa);
-
-	/*
-	 * Claim log blocks that haven't been committed yet.
-	 * This must all happen in a single txg.
-	 * Note: spa_claim_max_txg is updated by spa_claim_notify(),
-	 * invoked from zil_claim_log_block()'s i/o done callback.
-	 * Price of rollback is that we abandon the log.
-	 */
-	spa->spa_claiming = B_TRUE;
-
-	tx = dmu_tx_create_assigned(dp, spa_first_txg(spa));
-	(void) dmu_objset_find_dp(dp, dp->dp_root_dir_obj,
-	    zil_claim, tx, DS_FIND_CHILDREN);
-	dmu_tx_commit(tx);
-
-	spa->spa_claiming = B_FALSE;
-
-	spa_set_log_state(spa, SPA_LOG_GOOD);
-}
-
-static void
-spa_ld_check_for_config_update(spa_t *spa, uint64_t config_cache_txg,
-    boolean_t reloading)
-{
-	vdev_t *rvd = spa->spa_root_vdev;
-	int need_update = B_FALSE;
-
-	/*
-	 * If the config cache is stale, or we have uninitialized
-	 * metaslabs (see spa_vdev_add()), then update the config.
-	 *
-	 * If this is a verbatim import, trust the current
-	 * in-core spa_config and update the disk labels.
-	 */
-	if (reloading || config_cache_txg != spa->spa_config_txg ||
-	    spa->spa_load_state == SPA_LOAD_IMPORT ||
-	    spa->spa_load_state == SPA_LOAD_RECOVER ||
-	    (spa->spa_import_flags & ZFS_IMPORT_VERBATIM))
-		need_update = B_TRUE;
-
-	for (int c = 0; c < rvd->vdev_children; c++)
-		if (rvd->vdev_child[c]->vdev_ms_array == 0)
-			need_update = B_TRUE;
-
-	/*
-	 * Update the config cache asychronously in case we're the
-	 * root pool, in which case the config cache isn't writable yet.
-	 */
-	if (need_update)
-		spa_async_request(spa, SPA_ASYNC_CONFIG_UPDATE);
-}
-
-static void
-spa_ld_prepare_for_reload(spa_t *spa)
-{
-	int mode = spa->spa_mode;
-	int async_suspended = spa->spa_async_suspended;
-
-	spa_unload(spa);
-	spa_deactivate(spa);
-	spa_activate(spa, mode);
-
-	/*
-	 * We save the value of spa_async_suspended as it gets reset to 0 by
-	 * spa_unload(). We want to restore it back to the original value before
-	 * returning as we might be calling spa_async_resume() later.
-	 */
-	spa->spa_async_suspended = async_suspended;
-}
-
-/*
- * Load an existing storage pool, using the config provided. This config
- * describes which vdevs are part of the pool and is later validated against
- * partial configs present in each vdev's label and an entire copy of the
- * config stored in the MOS.
- */
-static int
-spa_load_impl(spa_t *spa, spa_import_type_t type, char **ereport,
-    boolean_t reloading)
-{
-	int error = 0;
-	boolean_t missing_feat_write = B_FALSE;
-
-	ASSERT(MUTEX_HELD(&spa_namespace_lock));
-	ASSERT(spa->spa_config_source != SPA_CONFIG_SRC_NONE);
-
-	/*
-	 * Never trust the config that is provided unless we are assembling
-	 * a pool following a split.
-	 * This means don't trust blkptrs and the vdev tree in general. This
-	 * also effectively puts the spa in read-only mode since
-	 * spa_writeable() checks for spa_trust_config to be true.
-	 * We will later load a trusted config from the MOS.
-	 */
-	if (type != SPA_IMPORT_ASSEMBLE)
-		spa->spa_trust_config = B_FALSE;
-
-	if (reloading)
-		spa_load_note(spa, "RELOADING");
-	else
-		spa_load_note(spa, "LOADING");
-
-	/*
-	 * Parse the config provided to create a vdev tree.
-	 */
-	error = spa_ld_parse_config(spa, type);
+	error = ddt_load(spa);
 	if (error != 0)
-		return (error);
+		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
-	/*
-	 * Now that we have the vdev tree, try to open each vdev. This involves
-	 * opening the underlying physical device, retrieving its geometry and
-	 * probing the vdev with a dummy I/O. The state of each vdev will be set
-	 * based on the success of those operations. After this we'll be ready
-	 * to read from the vdevs.
-	 */
-	error = spa_ld_open_vdevs(spa);
-	if (error != 0)
-		return (error);
+	spa_update_dspace(spa);
 
 	/*
-	 * Read the label of each vdev and make sure that the GUIDs stored
-	 * there match the GUIDs in the config provided.
-	 * If we're assembling a new pool that's been split off from an
-	 * existing pool, the labels haven't yet been updated so we skip
-	 * validation for now.
+	 * Validate the config, using the MOS config to fill in any
+	 * information which might be missing.  If we fail to validate
+	 * the config then declare the pool unfit for use. If we're
+	 * assembling a pool from a split, the log is not transferred
+	 * over.
 	 */
 	if (type != SPA_IMPORT_ASSEMBLE) {
-		error = spa_ld_validate_vdevs(spa);
-		if (error != 0)
-			return (error);
-	}
+		nvlist_t *nvconfig;
 
-	/*
-	 * Read vdev labels to find the best uberblock (i.e. latest, unless
-	 * spa_load_max_txg is set) and store it in spa_uberblock. We get the
-	 * list of features required to read blkptrs in the MOS from the vdev
-	 * label with the best uberblock and verify that our version of zfs
-	 * supports them all.
-	 */
-	error = spa_ld_select_uberblock(spa, type);
-	if (error != 0)
-		return (error);
+		if (load_nvlist(spa, spa->spa_config_object, &nvconfig) != 0)
+			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
-	/*
-	 * Pass that uberblock to the dsl_pool layer which will open the root
-	 * blkptr. This blkptr points to the latest version of the MOS and will
-	 * allow us to read its contents.
-	 */
-	error = spa_ld_open_rootbp(spa);
-	if (error != 0)
-		return (error);
+		if (!spa_config_valid(spa, nvconfig)) {
+			nvlist_free(nvconfig);
+			return (spa_vdev_err(rvd, VDEV_AUX_BAD_GUID_SUM,
+			    ENXIO));
+		}
+		nvlist_free(nvconfig);
 
-	/*
-	 * Retrieve the trusted config stored in the MOS and use it to create
-	 * a new, exact version of the vdev tree, then reopen all vdevs.
-	 */
-	error = spa_ld_load_trusted_config(spa, type, reloading);
-	if (error == EAGAIN) {
-		VERIFY(!reloading);
 		/*
-		 * Redo the loading process with the trusted config if it is
-		 * too different from the untrusted config.
+		 * Now that we've validated the config, check the state of the
+		 * root vdev.  If it can't be opened, it indicates one or
+		 * more toplevel vdevs are faulted.
 		 */
-		spa_ld_prepare_for_reload(spa);
-		return (spa_load_impl(spa, type, ereport, B_TRUE));
-	} else if (error != 0) {
-		return (error);
+		if (rvd->vdev_state <= VDEV_STATE_CANT_OPEN)
+			return (SET_ERROR(ENXIO));
+
+		if (spa_writeable(spa) && spa_check_logs(spa)) {
+			*ereport = FM_EREPORT_ZFS_LOG_REPLAY;
+			return (spa_vdev_err(rvd, VDEV_AUX_BAD_LOG, ENXIO));
+		}
 	}
 
-	/*
-	 * Retrieve the mapping of indirect vdevs. Those vdevs were removed
-	 * from the pool and their contents were re-mapped to other vdevs. Note
-	 * that everything that we read before this step must have been
-	 * rewritten on concrete vdevs after the last device removal was
-	 * initiated. Otherwise we could be reading from indirect vdevs before
-	 * we have loaded their mappings.
-	 */
-	error = spa_ld_open_indirect_vdev_metadata(spa);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Retrieve the full list of active features from the MOS and check if
-	 * they are all supported.
-	 */
-	error = spa_ld_check_features(spa, &missing_feat_write);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Load several special directories from the MOS needed by the dsl_pool
-	 * layer.
-	 */
-	error = spa_ld_load_special_directories(spa);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Retrieve pool properties from the MOS.
-	 */
-	error = spa_ld_get_props(spa);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Retrieve the list of auxiliary devices - cache devices and spares -
-	 * and open them.
-	 */
-	error = spa_ld_open_aux_vdevs(spa, type);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Load the metadata for all vdevs. Also check if unopenable devices
-	 * should be autoreplaced.
-	 */
-	error = spa_ld_load_vdev_metadata(spa);
-	if (error != 0)
-		return (error);
-
-	error = spa_ld_load_dedup_tables(spa);
-	if (error != 0)
-		return (error);
-
-	/*
-	 * Verify the logs now to make sure we don't have any unexpected errors
-	 * when we claim log blocks later.
-	 */
-	error = spa_ld_verify_logs(spa, type, ereport);
-	if (error != 0)
-		return (error);
-
 	if (missing_feat_write) {
-		ASSERT(spa->spa_load_state == SPA_LOAD_TRYIMPORT);
+		ASSERT(state == SPA_LOAD_TRYIMPORT);
 
 		/*
 		 * At this point, we know that we can open the pool in
@@ -3470,45 +3086,45 @@
 		 * read-only mode but not read-write mode. We now have enough
 		 * information and can return to userland.
 		 */
-		return (spa_vdev_err(spa->spa_root_vdev, VDEV_AUX_UNSUP_FEAT,
-		    ENOTSUP));
+		return (spa_vdev_err(rvd, VDEV_AUX_UNSUP_FEAT, ENOTSUP));
 	}
 
 	/*
-	 * Traverse the last txgs to make sure the pool was left off in a safe
-	 * state. When performing an extreme rewind, we verify the whole pool,
-	 * which can take a very long time.
+	 * We've successfully opened the pool, verify that we're ready
+	 * to start pushing transactions.
 	 */
-	error = spa_ld_verify_pool_data(spa);
-	if (error != 0)
-		return (error);
+	if (state != SPA_LOAD_TRYIMPORT) {
+		if (error = spa_load_verify(spa)) {
+			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA,
+			    error));
+		}
+	}
 
-	/*
-	 * Calculate the deflated space for the pool. This must be done before
-	 * we write anything to the pool because we'd need to update the space
-	 * accounting using the deflated sizes.
-	 */
-	spa_update_dspace(spa);
-
-	/*
-	 * We have now retrieved all the information we needed to open the
-	 * pool. If we are importing the pool in read-write mode, a few
-	 * additional steps must be performed to finish the import.
-	 */
-	if (spa_writeable(spa) && (spa->spa_load_state == SPA_LOAD_RECOVER ||
+	if (spa_writeable(spa) && (state == SPA_LOAD_RECOVER ||
 	    spa->spa_load_max_txg == UINT64_MAX)) {
-		uint64_t config_cache_txg = spa->spa_config_txg;
+		dmu_tx_t *tx;
+		int need_update = B_FALSE;
+		dsl_pool_t *dp = spa_get_dsl(spa);
 
-		ASSERT(spa->spa_load_state != SPA_LOAD_TRYIMPORT);
+		ASSERT(state != SPA_LOAD_TRYIMPORT);
 
 		/*
-		 * Traverse the ZIL and claim all blocks.
+		 * Claim log blocks that haven't been committed yet.
+		 * This must all happen in a single txg.
+		 * Note: spa_claim_max_txg is updated by spa_claim_notify(),
+		 * invoked from zil_claim_log_block()'s i/o done callback.
+		 * Price of rollback is that we abandon the log.
 		 */
-		spa_ld_claim_log_blocks(spa);
+		spa->spa_claiming = B_TRUE;
 
-		/*
-		 * Kick-off the syncing thread.
-		 */
+		tx = dmu_tx_create_assigned(dp, spa_first_txg(spa));
+		(void) dmu_objset_find_dp(dp, dp->dp_root_dir_obj,
+		    zil_claim, tx, DS_FIND_CHILDREN);
+		dmu_tx_commit(tx);
+
+		spa->spa_claiming = B_FALSE;
+
+		spa_set_log_state(spa, SPA_LOG_GOOD);
 		spa->spa_sync_on = B_TRUE;
 		txg_sync_start(spa->spa_dsl_pool);
 
@@ -3516,24 +3132,40 @@
 		 * Wait for all claims to sync.  We sync up to the highest
 		 * claimed log block birth time so that claimed log blocks
 		 * don't appear to be from the future.  spa_claim_max_txg
-		 * will have been set for us by ZIL traversal operations
-		 * performed above.
+		 * will have been set for us by either zil_check_log_chain()
+		 * (invoked from spa_check_logs()) or zil_claim() above.
 		 */
 		txg_wait_synced(spa->spa_dsl_pool, spa->spa_claim_max_txg);
 
 		/*
-		 * Check if we need to request an update of the config. On the
-		 * next sync, we would update the config stored in vdev labels
-		 * and the cachefile (by default /etc/zfs/zpool.cache).
+		 * If the config cache is stale, or we have uninitialized
+		 * metaslabs (see spa_vdev_add()), then update the config.
+		 *
+		 * If this is a verbatim import, trust the current
+		 * in-core spa_config and update the disk labels.
 		 */
-		spa_ld_check_for_config_update(spa, config_cache_txg,
-		    reloading);
+		if (config_cache_txg != spa->spa_config_txg ||
+		    state == SPA_LOAD_IMPORT ||
+		    state == SPA_LOAD_RECOVER ||
+		    (spa->spa_import_flags & ZFS_IMPORT_VERBATIM))
+			need_update = B_TRUE;
 
+		for (int c = 0; c < rvd->vdev_children; c++)
+			if (rvd->vdev_child[c]->vdev_ms_array == 0)
+				need_update = B_TRUE;
+
 		/*
+		 * Update the config cache asychronously in case we're the
+		 * root pool, in which case the config cache isn't writable yet.
+		 */
+		if (need_update)
+			spa_async_request(spa, SPA_ASYNC_CONFIG_UPDATE);
+
+		/*
 		 * Check all DTLs to see if anything needs resilvering.
 		 */
 		if (!dsl_scan_resilvering(spa->spa_dsl_pool) &&
-		    vdev_resilver_needed(spa->spa_root_vdev, NULL, NULL))
+		    vdev_resilver_needed(rvd, NULL, NULL))
 			spa_async_request(spa, SPA_ASYNC_RESILVER);
 
 		/*
@@ -3542,29 +3174,21 @@
 		 */
 		spa_history_log_version(spa, "open");
 
-		/*
-		 * Delete any inconsistent datasets.
-		 */
-		(void) dmu_objset_find(spa_name(spa),
-		    dsl_destroy_inconsistent, NULL, DS_FIND_CHILDREN);
+		dsl_destroy_inconsistent(spa_get_dsl(spa));
 
 		/*
 		 * Clean up any stale temporary dataset userrefs.
 		 */
 		dsl_pool_clean_tmp_userrefs(spa->spa_dsl_pool);
-
-		spa_restart_removal(spa);
-
-		spa_spawn_aux_threads(spa);
 	}
 
-	spa_load_note(spa, "LOADED");
+	spa_async_request(spa, SPA_ASYNC_L2CACHE_REBUILD);
 
 	return (0);
 }
 
 static int
-spa_load_retry(spa_t *spa, spa_load_state_t state)
+spa_load_retry(spa_t *spa, spa_load_state_t state, int mosconfig)
 {
 	int mode = spa->spa_mode;
 
@@ -3576,10 +3200,7 @@
 	spa_activate(spa, mode);
 	spa_async_suspend(spa);
 
-	spa_load_note(spa, "spa_load_retry: rewind, max txg: %llu",
-	    (u_longlong_t)spa->spa_load_max_txg);
-
-	return (spa_load(spa, state, SPA_IMPORT_EXISTING));
+	return (spa_load(spa, state, SPA_IMPORT_EXISTING, mosconfig));
 }
 
 /*
@@ -3590,8 +3211,8 @@
  * spa_load().
  */
 static int
-spa_load_best(spa_t *spa, spa_load_state_t state, uint64_t max_request,
-    int rewind_flags)
+spa_load_best(spa_t *spa, spa_load_state_t state, int mosconfig,
+    uint64_t max_request, int rewind_flags)
 {
 	nvlist_t *loadinfo = NULL;
 	nvlist_t *config = NULL;
@@ -3608,7 +3229,8 @@
 			spa->spa_extreme_rewind = B_TRUE;
 	}
 
-	load_error = rewind_error = spa_load(spa, state, SPA_IMPORT_EXISTING);
+	load_error = rewind_error = spa_load(spa, state, SPA_IMPORT_EXISTING,
+	    mosconfig);
 	if (load_error == 0)
 		return (0);
 
@@ -3649,7 +3271,7 @@
 	    spa->spa_uberblock.ub_txg <= spa->spa_load_max_txg) {
 		if (spa->spa_load_max_txg < safe_rewind_txg)
 			spa->spa_extreme_rewind = B_TRUE;
-		rewind_error = spa_load_retry(spa, state);
+		rewind_error = spa_load_retry(spa, state, mosconfig);
 	}
 
 	spa->spa_extreme_rewind = B_FALSE;
@@ -3696,6 +3318,7 @@
 	spa_load_state_t state = SPA_LOAD_OPEN;
 	int error;
 	int locked = B_FALSE;
+	boolean_t open_with_activation = B_FALSE;
 
 	*spapp = NULL;
 
@@ -3728,10 +3351,8 @@
 
 		if (state != SPA_LOAD_RECOVER)
 			spa->spa_last_ubsync_txg = spa->spa_load_txg = 0;
-		spa->spa_config_source = SPA_CONFIG_SRC_CACHEFILE;
 
-		zfs_dbgmsg("spa_open_common: opening %s", pool);
-		error = spa_load_best(spa, state, policy.zrp_txg,
+		error = spa_load_best(spa, state, B_FALSE, policy.zrp_txg,
 		    policy.zrp_request);
 
 		if (error == EBADF) {
@@ -3744,7 +3365,7 @@
 			 */
 			spa_unload(spa);
 			spa_deactivate(spa);
-			spa_write_cachefile(spa, B_TRUE, B_TRUE);
+			spa_config_sync(spa, B_TRUE, B_TRUE);
 			spa_remove(spa);
 			if (locked)
 				mutex_exit(&spa_namespace_lock);
@@ -3772,6 +3393,8 @@
 			*spapp = NULL;
 			return (error);
 		}
+
+		open_with_activation = B_TRUE;
 	}
 
 	spa_open_ref(spa, tag);
@@ -3795,6 +3418,9 @@
 		mutex_exit(&spa_namespace_lock);
 	}
 
+	if (open_with_activation)
+		wbc_activate(spa, B_FALSE);
+
 	*spapp = spa;
 
 	return (0);
@@ -4244,7 +3870,8 @@
 	nvlist_t **spares, **l2cache;
 	uint_t nspares, nl2cache;
 	uint64_t version, obj;
-	boolean_t has_features;
+	boolean_t has_features = B_FALSE, wbc_feature_exists = B_FALSE;
+	spa_meta_placement_t *mp;
 
 	/*
 	 * If this pool already exists, return failure.
@@ -4263,20 +3890,46 @@
 	spa = spa_add(pool, NULL, altroot);
 	spa_activate(spa, spa_mode_global);
 
-	if (props && (error = spa_prop_validate(spa, props))) {
-		spa_deactivate(spa);
-		spa_remove(spa);
-		mutex_exit(&spa_namespace_lock);
-		return (error);
-	}
+	if (props != NULL) {
+		nvpair_t *wbc_feature_nvp = NULL;
 
-	has_features = B_FALSE;
-	for (nvpair_t *elem = nvlist_next_nvpair(props, NULL);
-	    elem != NULL; elem = nvlist_next_nvpair(props, elem)) {
-		if (zpool_prop_feature(nvpair_name(elem)))
-			has_features = B_TRUE;
+		for (nvpair_t *elem = nvlist_next_nvpair(props, NULL);
+		    elem != NULL; elem = nvlist_next_nvpair(props, elem)) {
+			const char *propname = nvpair_name(elem);
+			if (zpool_prop_feature(propname)) {
+				spa_feature_t feature;
+				int err;
+				const char *fname = strchr(propname, '@') + 1;
+
+				err = zfeature_lookup_name(fname, &feature);
+				if (err == 0 && feature == SPA_FEATURE_WBC) {
+					wbc_feature_nvp = elem;
+					wbc_feature_exists = B_TRUE;
+				}
+
+				has_features = B_TRUE;
+			}
+		}
+
+		/*
+		 * We do not want to enabled feature@wbc if
+		 * this pool does not have special vdev.
+		 * At this stage we remove this feature from common list,
+		 * but later after check that special vdev available this
+		 * feature will be enabled
+		 */
+		if (wbc_feature_nvp != NULL)
+			fnvlist_remove_nvpair(props, wbc_feature_nvp);
+
+		if ((error = spa_prop_validate(spa, props)) != 0) {
+			spa_deactivate(spa);
+			spa_remove(spa);
+			mutex_exit(&spa_namespace_lock);
+			return (error);
+		}
 	}
 
+
 	if (has_features || nvlist_lookup_uint64(props,
 	    zpool_prop_to_name(ZPOOL_PROP_VERSION), &version) != 0) {
 		version = SPA_VERSION;
@@ -4288,9 +3941,6 @@
 	spa->spa_uberblock.ub_version = version;
 	spa->spa_ubsync = spa->spa_uberblock;
 	spa->spa_load_state = SPA_LOAD_CREATE;
-	spa->spa_removing_phys.sr_state = DSS_NONE;
-	spa->spa_removing_phys.sr_removing_vdev = -1;
-	spa->spa_removing_phys.sr_prev_indirect_vdev = -1;
 
 	/*
 	 * Create "The Godfather" zio to hold all async IOs
@@ -4434,6 +4084,8 @@
 	if (version >= SPA_VERSION_ZPOOL_HISTORY)
 		spa_history_create_obj(spa, tx);
 
+	mp = &spa->spa_meta_policy;
+
 	/*
 	 * Generate some random noise for salted checksums to operate on.
 	 */
@@ -4447,12 +4099,55 @@
 	spa->spa_delegation = zpool_prop_default_numeric(ZPOOL_PROP_DELEGATION);
 	spa->spa_failmode = zpool_prop_default_numeric(ZPOOL_PROP_FAILUREMODE);
 	spa->spa_autoexpand = zpool_prop_default_numeric(ZPOOL_PROP_AUTOEXPAND);
+	spa->spa_minwat = zpool_prop_default_numeric(ZPOOL_PROP_MINWATERMARK);
+	spa->spa_hiwat = zpool_prop_default_numeric(ZPOOL_PROP_HIWATERMARK);
+	spa->spa_lowat = zpool_prop_default_numeric(ZPOOL_PROP_LOWATERMARK);
+	spa->spa_ddt_meta_copies =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUPMETA_DITTO);
+	spa->spa_dedup_best_effort =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUP_BEST_EFFORT);
+	spa->spa_dedup_lo_best_effort =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUP_LO_BEST_EFFORT);
+	spa->spa_dedup_hi_best_effort =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DEDUP_HI_BEST_EFFORT);
+	spa->spa_force_trim = zpool_prop_default_numeric(ZPOOL_PROP_FORCETRIM);
 
+	spa->spa_resilver_prio =
+	    zpool_prop_default_numeric(ZPOOL_PROP_RESILVER_PRIO);
+	spa->spa_scrub_prio = zpool_prop_default_numeric(ZPOOL_PROP_SCRUB_PRIO);
+
+	mutex_enter(&spa->spa_auto_trim_lock);
+	spa->spa_auto_trim = zpool_prop_default_numeric(ZPOOL_PROP_AUTOTRIM);
+	if (spa->spa_auto_trim == SPA_AUTO_TRIM_ON)
+		spa_auto_trim_taskq_create(spa);
+	mutex_exit(&spa->spa_auto_trim_lock);
+
+	mp->spa_enable_meta_placement_selection =
+	    zpool_prop_default_numeric(ZPOOL_PROP_META_PLACEMENT);
+	mp->spa_sync_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_SYNC_TO_SPECIAL);
+	mp->spa_ddt_meta_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_DDT_META_TO_METADEV);
+	mp->spa_zfs_meta_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_ZFS_META_TO_METADEV);
+	mp->spa_small_data_to_special =
+	    zpool_prop_default_numeric(ZPOOL_PROP_SMALL_DATA_TO_METADEV);
+
+	spa_set_ddt_classes(spa, 0);
+
 	if (props != NULL) {
 		spa_configfile_set(spa, props, B_FALSE);
 		spa_sync_props(props, tx);
 	}
 
+	if (spa_has_special(spa)) {
+		spa_feature_enable(spa, SPA_FEATURE_META_DEVICES, tx);
+		spa_feature_incr(spa, SPA_FEATURE_META_DEVICES, tx);
+
+		if (wbc_feature_exists)
+			spa_feature_enable(spa, SPA_FEATURE_WBC, tx);
+	}
+
 	dmu_tx_commit(tx);
 
 	spa->spa_sync_on = B_TRUE;
@@ -4464,9 +4159,7 @@
 	 */
 	txg_wait_synced(spa->spa_dsl_pool, txg);
 
-	spa_spawn_aux_threads(spa);
-
-	spa_write_cachefile(spa, B_FALSE, B_TRUE);
+	spa_config_sync(spa, B_FALSE, B_TRUE);
 	spa_event_notify(spa, NULL, NULL, ESC_ZFS_POOL_CREATE);
 
 	spa_history_log_version(spa, "create");
@@ -4481,9 +4174,57 @@
 
 	mutex_exit(&spa_namespace_lock);
 
+	wbc_activate(spa, B_TRUE);
+
 	return (0);
 }
 
+
+/*
+ * See if the pool has special tier, and if so, enable/activate
+ * the feature as needed. Activation is not reference counted.
+ */
+static void
+spa_check_special_feature(spa_t *spa)
+{
+	if (spa_has_special(spa)) {
+		nvlist_t *props = NULL;
+
+		if (!spa_feature_is_enabled(spa, SPA_FEATURE_META_DEVICES)) {
+			VERIFY(nvlist_alloc(&props, NV_UNIQUE_NAME, 0) == 0);
+			VERIFY(nvlist_add_uint64(props,
+			    FEATURE_META_DEVICES, 0) == 0);
+			VERIFY(spa_prop_set(spa, props) == 0);
+			nvlist_free(props);
+		}
+
+		if (!spa_feature_is_active(spa, SPA_FEATURE_META_DEVICES)) {
+			dmu_tx_t *tx =
+			    dmu_tx_create_dd(spa->spa_dsl_pool->dp_mos_dir);
+
+			VERIFY(dmu_tx_assign(tx, TXG_WAIT) == 0);
+			spa_feature_incr(spa, SPA_FEATURE_META_DEVICES, tx);
+			dmu_tx_commit(tx);
+		}
+	}
+}
+
+static void
+spa_special_feature_activate(void *arg, dmu_tx_t *tx)
+{
+	spa_t *spa = (spa_t *)arg;
+
+	if (spa_has_special(spa)) {
+		/* enable and activate as needed */
+		spa_feature_enable(spa, SPA_FEATURE_META_DEVICES, tx);
+		if (!spa_feature_is_active(spa, SPA_FEATURE_META_DEVICES)) {
+			spa_feature_incr(spa, SPA_FEATURE_META_DEVICES, tx);
+		}
+
+		spa_feature_enable(spa, SPA_FEATURE_WBC, tx);
+	}
+}
+
 #ifdef _KERNEL
 /*
  * Get the root pool information from the root disk, then import the root pool
@@ -4609,7 +4350,7 @@
 	VERIFY(nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_TXG, &txg) == 0);
 
 	mutex_enter(&spa_namespace_lock);
-	if ((spa = spa_lookup(pname)) != NULL) {
+	if ((spa = spa_lookup(pname)) != NULL || spa_config_guid_exists(guid)) {
 		/*
 		 * Remove the existing root pool from the namespace so that we
 		 * can replace it with the correct config we just read in.
@@ -4620,9 +4361,6 @@
 	spa = spa_add(pname, config, NULL);
 	spa->spa_is_root = B_TRUE;
 	spa->spa_import_flags = ZFS_IMPORT_VERBATIM;
-	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_VERSION,
-	    &spa->spa_ubsync.ub_version) != 0)
-		spa->spa_ubsync.ub_version = SPA_VERSION_INITIAL;
 
 	/*
 	 * Build up a vdev tree based on the boot device's label config.
@@ -4706,12 +4444,16 @@
 	nvlist_t *nvroot;
 	nvlist_t **spares, **l2cache;
 	uint_t nspares, nl2cache;
+	uint64_t guid;
 
+	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_GUID, &guid) != 0)
+		return (SET_ERROR(EINVAL));
+
 	/*
 	 * If a pool with this name exists, return failure.
 	 */
 	mutex_enter(&spa_namespace_lock);
-	if (spa_lookup(pool) != NULL) {
+	if (spa_lookup(pool) != NULL || spa_config_guid_exists(guid)) {
 		mutex_exit(&spa_namespace_lock);
 		return (SET_ERROR(EEXIST));
 	}
@@ -4736,9 +4478,9 @@
 		if (props != NULL)
 			spa_configfile_set(spa, props, B_FALSE);
 
-		spa_write_cachefile(spa, B_FALSE, B_TRUE);
+		spa_config_sync(spa, B_FALSE, B_TRUE);
 		spa_event_notify(spa, NULL, NULL, ESC_ZFS_POOL_IMPORT);
-		zfs_dbgmsg("spa_import: verbatim import of %s", pool);
+
 		mutex_exit(&spa_namespace_lock);
 		return (0);
 	}
